/**
 * @version 0.1
 * @author Majid Ali Khan
 */
package yaes.framework.world.map;

import yaes.framework.algorithm.pathplanning.cache.PathCache;

/**
 * 
 */
public class PathPlanner {
	private static PathPlanner instance;

	public static PathPlanner getInstance() {
		if (PathPlanner.instance == null) {
			PathPlanner.instance = new PathPlanner();
		}
		return PathPlanner.instance;
	}

	protected PathPlanner() {
	}

	// plan for path assuming only white region is accessible
	public PlannedPath planPath(IMap map, Location from, Location to) {
		final PlannedPath path = new PlannedPath(from, to);
		final boolean whiteAccessible = true;
		PathCache.findPath(path, map, whiteAccessible);
		return path;
	}
}
