package yaes.framework.world.sensornetwork;

import yaes.framework.agent.AbstractCommunicatingAgent;
import yaes.framework.entity.control.speedcontrol.PathFollowControl;
import yaes.framework.world.World;
import yaes.framework.world.map.Location;
import yaes.framework.world.map.PlannedPath;

public class ActuatorAgent extends AbstractCommunicatingAgent {
	private ActuatorNode node;
	private PlannedPath path = null;
	private PathFollowControl control = null;
	private final double speed = 1;

	public ActuatorAgent(String name, World world, PlannedPath path) {
		super(name, world);
		this.path = path;
	}

	public void action() {
		// initialy, follow the path of the agent
		if ((control == null) && (path != null)) {
			node.setLocation(path.getSource());
			control = new PathFollowControl(path, speed, world.getTime());
			control.setControllable(node);
			node.addControl(control);
		}
		// if we reach the destination: restart the agent with the same path
		if ((path != null) && node.getLocation().equals(path.getDestination())) {
			node.removeControl(control);
			control = null;
			final Location src = path.getLocationList().get(0);
			path.setSource(src);
		}
	}

	public ActuatorNode getNode() {
		return node;
	}

	public void setNode(ActuatorNode node) {
		this.node = node;
	}

	@Override
	public String toString() {
		String returnValue = "";
		returnValue += getName();
		if (getNode() != null) {
			returnValue += "\t Location: " + getNode().getLocation();
		}
		return returnValue;
	}
}
