package yaes.framework.world.sensornetwork;

import yaes.framework.entity.control.ControlException;
import yaes.framework.entity.vehicle.Vehicle;
import yaes.framework.world.map.Location;

public class ActuatorNode extends Vehicle {
	private final SensorNetworkWorld sensingManager;

	public ActuatorNode(Location initLocation, String name,
			SensorNetworkWorld sensingManager) {
		super(initLocation, name);
		this.sensingManager = sensingManager;
	}

	/**
	 * The action of the ActuatorNode basically is about reading out its
	 * perceptions, basically the overhearing
	 */
	public void action() {
		// nothing here
	}

	@Override
	public String toString() {
		return "Actuator Node, location = " + getLocation();
	}

	@Override
	public void update(double time) throws ControlException {
		super.update(time);
		sensingManager.move(this);
		action();
	}
}
