package yaes.framework.world.sensornetwork;

import java.util.Observable;

import yaes.framework.entity.control.ControlException;
import yaes.framework.world.map.INamed;
import yaes.framework.world.map.IObjectWithLocation;
import yaes.framework.world.map.Location;
import yaes.ui.text.TextUi;

public class SensorNode extends Observable implements IObjectWithLocation,
		INamed {
	private String name;
	private Location location;
	private AbstractSensorAgent agent;

	public AbstractSensorAgent getAgent() {
		return agent;
	}

	public Location getLocation() {
		return location;
	}

	public String getName() {
		return name;
	}

	public void setAgent(AbstractSensorAgent agent) {
		this.agent = agent;
	}

	public void setLocation(Location location) {
		this.location = location;
	}

	public void setName(String name) {
		this.name = name;
	}

	/**
	 * toString
	 */
	@Override
	public String toString() {
		final StringBuffer buffer = new StringBuffer("SensorNode " + getName()
				+ " at " + location.toString());
		if (agent == null) {
			buffer.append("\nNo controlling agent");
		} else {
			buffer.append("\n" + agent.toString());
		}
		return buffer.toString();
	}

	public void update() throws ControlException {
		if (agent != null) {
			agent.action();
		} else {
			TextUi.println("This node " + name
					+ " does not have a controlling agent");
		}
		setChanged();
		notifyObservers();
	}
}
