/*
 * Created on Apr 7, 2007
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package yaes.ui.plot;

import java.util.List;

public class MatlabUtil {

	/**
	 * Returns a two dimensional matrix description in Matlab
	 * 
	 * @param varName
	 * @param z
	 * @return
	 */
	public static String getMatlabMatrix(String varName, double[][] values) {
		final StringBuffer buffer = new StringBuffer(varName + " = [");
		for (int i = 0; i < values.length; i++) {
			final double[] line = values[i];
			for (final int j = 0; j < line.length; i++) {
				buffer.append(line[j] + " ");
			}
			buffer.append("\n");
		}
		buffer.append("]\n");
		return buffer.toString();
	}

	/**
	 * Returns a one dimensional vector description in Matlab.
	 * 
	 * @return
	 */
	public static String getMatlabVector(String varName, double[] values) {
		final StringBuffer buffer = new StringBuffer(varName + " = [");
		for (double element : values) {
			buffer.append(element + " ");
		}
		buffer.append("]\n");
		return buffer.toString();
	}

	/**
	 * Returns a one dimensional vector description in Matlab for a List<Double>
	 */
	public static String getMatlabVector(String varName,
			List<? extends Number> values) {
		final StringBuffer buffer = new StringBuffer(varName + " = [");
		for (Number n : values) {
			buffer.append(n + " ");
		}
		buffer.append("]\n");
		return buffer.toString();
	}
}
