package yaes.ui.propertysheet;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.logging.Logger;

import yaes.ui.text.TextUi;

public class Editors {
	private static Logger LOGGER = Logger
			.getLogger("com.cplane.ic.gui.propertysheet");
	private static boolean initialized = false;
	@SuppressWarnings("unchecked")
	private static HashMap<String, Class> editorsTable;
	private static ArrayList<EditorDescriptor> editorDescriptors = new ArrayList<EditorDescriptor>();

	@SuppressWarnings("unchecked")
	static public Class getEditorClass(Class clazz) {
		return Editors.editorsTable.get(clazz.getName());
	}

	@SuppressWarnings("unchecked")
	public static HashMap<String, Class> getTable() {
		return Editors.editorsTable;
	}

	private static void initEditors() {
		Editors.editorDescriptors.add(new EditorDescriptor("java.awt.Color",
				"yaes.ui.propertysheet.editors.ColorEditor"));
		Editors.editorDescriptors.add(new EditorDescriptor("java.awt.Font",
				"yaes.ui.propertysheet.editors.FontEditor"));
		Editors.editorDescriptors.add(new EditorDescriptor("java.io.File",
				"yaes.ui.propertysheet.editors.FileEditor"));
		Editors.editorDescriptors.add(new EditorDescriptor("java.lang.Integer",
				"yaes.ui.propertysheet.editors.IntEditor"));
		Editors.editorDescriptors.add(new EditorDescriptor("java.lang.Short",
				"yaes.ui.propertysheet.editors.ShortEditor"));
		Editors.editorDescriptors.add(new EditorDescriptor("java.lang.Long",
				"yaes.ui.propertysheet.editors.LongEditor"));
		Editors.editorDescriptors.add(new EditorDescriptor("java.lang.Byte",
				"yaes.ui.propertysheet.editors.ByteEditor"));
		Editors.editorDescriptors.add(new EditorDescriptor("java.lang.Boolean",
				"yaes.ui.propertysheet.editors.BoolEditor"));
		Editors.editorDescriptors.add(new EditorDescriptor("java.lang.Float",
				"yaes.ui.propertysheet.editors.FloatEditor"));
		Editors.editorDescriptors.add(new EditorDescriptor("java.lang.Double",
				"yaes.ui.propertysheet.editors.DoubleEditor"));
		Editors.editorDescriptors.add(new EditorDescriptor("java.lang.String",
				"yaes.ui.propertysheet.editors.StringEditor"));
	}

	@SuppressWarnings("unchecked")
	static public synchronized void setCustomEditors() {
		TextUi.println("setCustomEditors");
		if (Editors.initialized) {
			return;
		}
		Editors.initEditors();
		Editors.editorsTable = new HashMap<String, Class>();
		for (final EditorDescriptor descriptor : Editors.editorDescriptors) {
			try {
				final Class clazz = Class.forName(descriptor
						.getEditorClassName());
				Editors.editorsTable
						.put(descriptor.getObjectClassName(), clazz);
			} catch (final ClassNotFoundException exc) {
				Editors.LOGGER.severe("ClassNotFoundException " + exc);
			}
		}
		Editors.initialized = true;
	}

	public Editors() {
		Editors.initEditors();
	}
}
