package yaes.ui.propertysheet;

public class FileFilters {
	public static class BinFilter extends FileExtensionFilter {
		// Accept all directories and all dat files.
		public BinFilter() {
			super("Binary files (*.dat)");
			addExtension(".dat");
		}
	}

	public static class ClassFileFilter extends FileExtensionFilter {
		public ClassFileFilter() {
			super("Class files (*.class)");
			addExtension(".class");
		}
	}

	public static class HtmlFilter extends FileExtensionFilter {
		public HtmlFilter() {
			super("HTML files (*.html)");
			addExtension(".html");
			addExtension(".htm");
		}
	}

	public static class JpegFilter extends FileExtensionFilter {
		public JpegFilter() {
			super("JPEG files (*.jpg)");
			addExtension(".jpg");
		}
	}

	public static class JythonFileFilter extends FileExtensionFilter {
		public JythonFileFilter() {
			super("Jython files (*.py)");
			addExtension(".py");
		}
	}

	public static class PictureFilter extends FileExtensionFilter {
		public PictureFilter() {
			super("Picture files (*.jpg, *.gif, *.png)");
			addExtension(".jpg");
			addExtension(".gif");
			addExtension(".png");
		}
	}

	public static class TCLFileFilter extends FileExtensionFilter {
		public TCLFileFilter() {
			super("TCL files (*.tcl)");
			addExtension(".tcl");
		}
	}

	public static class XmlFilter extends FileExtensionFilter {
		public XmlFilter() {
			super("XML files (*.xml)");
			addExtension(".xml");
		}
	}
}